package blanco.plugin.jsf.actions;

import java.io.File;
import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.PlatformUI;

import blanco.jsf.BlancoJsfConstants;
import blanco.jsf.BlancoJsfMeta2Xml;
import blanco.jsf.BlancoJsfXml2ConfigFile;
import blanco.jsf.BlancoJsfXml2SourceFile;
import blanco.jsf.resourcebundle.BlancoJsfResourceBundle;
import blanco.jsf.task.valueobject.BlancoJsfProcessInput;
import blanco.jsf.valueobject.BlancoJsfStructure;
import blanco.plugin.jsf.BlancoJsfPlugin;
import blanco.plugin.jsf.BlancoJsfPluginConstants;
import blanco.plugin.jsf.editors.BlancoJsfPluginUtil;

public class BlancoJsfGenerateAction {
    private static final BlancoJsfResourceBundle fBundle = new BlancoJsfResourceBundle();

    /**
     * ソースコード生成処理を実行します。
     * 
     * @param ifile
     *            処理対象のファイル。
     * @param shell
     *            親のシェル。
     * @param workbenchMonitor
     *            ワークベンチモニタ。
     * @param targetLang
     *            出力対象プログラミング言語。
     * @param metaDir
     *            メタディレクトリ。
     * @throws InvocationTargetException
     *             実行時の例外。
     * @throws InterruptedException
     *             割り込み例外。
     */
    public static final void processBlancoJsfSource(final IFile ifile,
            final Shell shell, IProgressMonitor workbenchMonitor,
            final String runtimePackage, final String metaDir)
            throws InvocationTargetException, InterruptedException {
        if (ifile.getProject().getFolder(metaDir).exists() == false) {
            MessageDialog.openWarning(shell, "ソースコード生成", "メタディレクトリ (" + metaDir
                    + ") が存在しません。処理を中断します。");
            return;
        }

        final BlancoJsfProcessInput input = new BlancoJsfProcessInput();
        input.setMetadir(metaDir);
        input.setRuntimepackage(runtimePackage);

        {
            final IFolder tempRootFolder = ifile.getProject().getFolder("tmp");
            input.setTmpdir(tempRootFolder.getLocation().toFile()
                    .getAbsolutePath());
        }

        {
            final IFolder folderTargetDirectory = ifile.getProject().getFolder(
                    "blanco");
            final File blancoTargetDirectory = folderTargetDirectory
                    .getLocation().toFile();
            input.setTargetdir(blancoTargetDirectory.getAbsolutePath());
            input.setTargetdirjee(blancoTargetDirectory.getAbsolutePath());
        }

        {
            final IFolder folderXmlDirectory = ifile.getProject().getFolder(
                    "blanco.xml");
            final File blancoXmlDirectory = folderXmlDirectory.getLocation()
                    .toFile();
            input.setTargetdirxml(blancoXmlDirectory.getAbsolutePath());
        }

        // Eclipse 3.3 対策: begin
        // workbenchMonitorを利用することを停止しました。
        // org.eclipse.swt.SWTException: Invalid thread access が発生してしまいます。
        // Eclipse 3.3 対策: end

        try {
            // PlatformUI.getWorkbench().getProgressService()を有益と判断。
            PlatformUI.getWorkbench().getProgressService().busyCursorWhile(
                    new IRunnableWithProgress() {
                        public void run(final IProgressMonitor monitor)
                                throws InvocationTargetException,
                                InterruptedException {
                            try {
                                monitor.beginTask(
                                        BlancoJsfConstants.PRODUCT_NAME
                                                + "ソースコード生成", 10);

                                if (monitor.isCanceled()) {
                                    return;
                                }

                                monitor.subTask("ディレクトリ: テンポラリフォルダの調整。");

                                // テンポラリフォルダを一旦削除します。
                                BlancoJsfPluginUtil
                                        .deleteFolder(
                                                ifile,
                                                monitor,
                                                "tmp"
                                                        + BlancoJsfConstants.TARGET_SUBDIRECTORY);
                                BlancoJsfPluginUtil
                                        .createFolder(
                                                ifile,
                                                monitor,
                                                "tmp"
                                                        + BlancoJsfConstants.TARGET_SUBDIRECTORY);
                                final IFolder tempFolder = BlancoJsfPluginUtil
                                        .findFolder(
                                                ifile,
                                                monitor,
                                                "tmp"
                                                        + BlancoJsfConstants.TARGET_SUBDIRECTORY);

                                // ドキュメント一覧のための中間ファイル用ディレクトリ。
                                final File blancoTempDirectoryDocListing = ifile
                                        .getProject().getFolder(
                                                "tmp/doclisting").getLocation()
                                        .toFile();
                                blancoTempDirectoryDocListing.mkdirs();

                                if (monitor.isCanceled()) {
                                    return;
                                }

                                monitor.subTask(fBundle
                                        .getMetafileDisplayname()
                                        + " (*.xls)を処理します");
                                monitor.worked(1);

                                final IFolder findFolder = BlancoJsfPluginUtil
                                        .findFolder(ifile, monitor, metaDir);
                                findFolder.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);

                                new BlancoJsfMeta2Xml() {
                                    protected boolean progress(
                                            final int progressCurrent,
                                            final int progressTotal,
                                            final String progressItem) {
                                        if (monitor.isCanceled()) {
                                            // 処理中断します。
                                            return false;
                                        }

                                        monitor.subTask("メタファイル処理: ファイル["
                                                + progressItem + "]を処理します ("
                                                + progressCurrent + "/"
                                                + progressTotal + ")");

                                        if (BlancoJsfPluginConstants.IS_DEBUG) {
                                            try {
                                                Thread.sleep(10000);
                                            } catch (InterruptedException e) {
                                                e.printStackTrace();
                                            }
                                        }

                                        return true;
                                    }
                                }.processDirectory(findFolder.getLocation()
                                        .toFile(), tempFolder.getLocation()
                                        .toFile().getAbsolutePath());

                                if (monitor.isCanceled()) {
                                    return;
                                }

                                monitor.subTask("フォルダ更新: tmpフォルダ");
                                monitor.worked(1);

                                tempFolder.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);

                                monitor.subTask("フォルダ作成: " + "フォルダ");

                                IFolder folderTargetDirectory = ifile
                                        .getProject().getFolder("blanco");
                                if (ifile.getProject().getFolder(metaDir)
                                        .exists() == false) {
                                    folderTargetDirectory.create(true, true,
                                            monitor);
                                }

                                monitor.subTask("フォルダ作成: " + "blanco"
                                        + "/mainフォルダ");
                                final IFolder folderTargetDirectoryWithMain = folderTargetDirectory
                                        .getFolder("main");
                                if (ifile.getProject().getFolder(metaDir)
                                        .exists() == false) {
                                    folderTargetDirectoryWithMain.create(true,
                                            true, monitor);
                                }

                                monitor.subTask("ソースコード作成");
                                monitor.worked(1);

                                final List<BlancoJsfStructure> jsfStructureList = new ArrayList<BlancoJsfStructure>();

                                IResource[] resourcesXml2 = tempFolder
                                        .members();
                                for (int index = 0; index < resourcesXml2.length; index++) {
                                    if (monitor.isCanceled()) {
                                        return;
                                    }
                                    if (resourcesXml2[index] instanceof IFile) {
                                        IFile fileLook = (IFile) resourcesXml2[index];
                                        if (fileLook.getFileExtension().equals(
                                                "xml") == false) {
                                            // 拡張子がxml以外のファイルはスキップします。
                                            continue;
                                        }

                                        monitor.subTask("ソースコード作成: ファイル["
                                                + fileLook.getName()
                                                + "]を処理します (" + (index + 1)
                                                + "/" + resourcesXml2.length
                                                + ")");

                                        try {
                                            // TODO Java と JEE との出力先フォルダーの調整。

                                            final IFolder tempRootFolder = BlancoJsfPluginUtil
                                                    .findFolder(ifile, monitor,
                                                            "tmp");
                                            tempRootFolder.refreshLocal(
                                                    IResource.DEPTH_INFINITE,
                                                    monitor);

                                            jsfStructureList
                                                    .addAll(new BlancoJsfXml2SourceFile()
                                                            .parse(
                                                                    fileLook
                                                                            .getLocation()
                                                                            .toFile(),
                                                                    input));
                                        } catch (IllegalArgumentException ex) {
                                            throw new IllegalArgumentException(

                                                    "ファイル["
                                                            + fileLook
                                                                    .getName()
                                                            + "]の処理中にエラーが発生しました。処理を中断します。\n\n"
                                                            + ex.toString());
                                        }

                                        if (BlancoJsfPluginConstants.IS_DEBUG) {
                                            Thread.sleep(1000);
                                        }

                                    }
                                }

                                {
                                    for (BlancoJsfStructure structure : jsfStructureList) {
                                        new BlancoJsfXml2SourceFile().process(
                                                structure, jsfStructureList,
                                                input);
                                    }

                                    new BlancoJsfXml2ConfigFile()
                                            .structure2Xml(jsfStructureList,
                                                    input);

                                    final IFolder folderXmlDirectory = ifile
                                            .getProject().getFolder(
                                                    "blanco.xml");
                                    folderXmlDirectory.refreshLocal(
                                            IResource.DEPTH_INFINITE, monitor);
                                }

                                if (monitor.isCanceled()) {
                                    return;
                                }

                                monitor.subTask("ドキュメント一覧のための中間ファイルを作成。");
                                monitor.worked(1);

                                monitor.subTask("フォルダ更新: " + "フォルダを更新");
                                monitor.worked(1);

                                if (monitor.isCanceled()) {
                                    return;
                                }

                                folderTargetDirectory.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);

                                if (BlancoJsfPluginConstants.IS_DEBUG) {
                                    Thread.sleep(1000);
                                }
                            } catch (Exception e) {
                                // 最終防衛ライン
                                e.printStackTrace();
                                throw new InvocationTargetException(e, e
                                        .toString());
                            } catch (Error e) {
                                // 最終防衛ライン
                                e.printStackTrace();
                                throw new InvocationTargetException(e, e
                                        .toString());
                            } finally {
                                // 最後の最後では done扱いとします。
                                monitor.done();
                            }
                        }
                    });
        } catch (InvocationTargetException ex) {
            BlancoJsfPlugin.log(ex);
            // 例外の中から本当の原因を取り出すことがポイントです。
            MessageDialog.openWarning(shell, "ソースコード生成",
                    "例外が発生しました。処理を中断します。\n" + ex.getCause().toString());
            ex.printStackTrace();
        } catch (InterruptedException ex) {
            BlancoJsfPlugin.log(ex);
            MessageDialog.openWarning(shell, "ソースコード生成",
                    "割り込み中断例外が発生しました。処理を中断します。\n" + ex.toString());
            ex.printStackTrace();
        } catch (Exception ex) {
            BlancoJsfPlugin.log(ex);
            MessageDialog.openWarning(shell, "ソースコード生成",
                    "予期せぬ例外が発生しました。処理を中断します。\n" + ex.toString());
            ex.printStackTrace();
        } catch (Error er) {
            BlancoJsfPlugin.log(er);
            MessageDialog.openWarning(shell, "ソースコード生成",
                    "予期せぬエラーが発生しました。処理を中断します。\n" + er.toString());
            er.printStackTrace();
        }
    }
}